
import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.NoValueException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class Item
    extends MarshallableObject
    implements Element
{

    private int _Number;
    private boolean has_Number = false;
    private int _Priority;
    private boolean has_Priority = false;
    private String _Description;
    private int _State;
    private boolean has_State = false;

    public int getNumber() {
        if (has_Number) {
            return _Number;
        }
        throw new NoValueException("number");
    }

    public void setNumber(int _Number) {
        this._Number = _Number;
        has_Number = true;
        invalidate();
    }

    public boolean hasNumber() {
        return has_Number;
    }

    public void deleteNumber() {
        has_Number = false;
        invalidate();
    }

    public int getPriority() {
        if (has_Priority) {
            return _Priority;
        }
        throw new NoValueException("priority");
    }

    public void setPriority(int _Priority) {
        this._Priority = _Priority;
        has_Priority = true;
        invalidate();
    }

    public boolean hasPriority() {
        return has_Priority;
    }

    public void deletePriority() {
        has_Priority = false;
        invalidate();
    }

    public String getDescription() {
        return _Description;
    }

    public void setDescription(String _Description) {
        this._Description = _Description;
        if (_Description == null) {
            invalidate();
        }
    }

    public int getState() {
        if (has_State) {
            return _State;
        }
        throw new NoValueException("state");
    }

    public void setState(int _State) {
        this._State = _State;
        has_State = true;
        invalidate();
    }

    public boolean hasState() {
        return has_State;
    }

    public void deleteState() {
        has_State = false;
        invalidate();
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (!has_Number) {
            throw new MissingContentException("number");
        }
        if (!has_Priority) {
            throw new MissingContentException("priority");
        }
        if (_Description == null) {
            throw new MissingContentException("description");
        }
        if (!has_State) {
            throw new MissingContentException("state");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("item");
        if (has_Number) {
            w.leaf("number", Integer.toString(_Number));
        }
        if (has_Priority) {
            w.leaf("priority", Integer.toString(_Priority));
        }
        w.leaf("description", _Description.toString());
        if (has_State) {
            w.leaf("state", Integer.toString(_State));
        }
        w.end("item");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("item");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        {
            xs.takeStart("number");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Number = Integer.parseInt(s);
            } catch (Exception x) {
                throw new ConversionException("number", x);
            }
            has_Number = true;
            xs.takeEnd("number");
        }
        {
            xs.takeStart("priority");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Priority = Integer.parseInt(s);
            } catch (Exception x) {
                throw new ConversionException("priority", x);
            }
            has_Priority = true;
            xs.takeEnd("priority");
        }
        if (xs.atStart("description")) {
            xs.takeStart("description");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Description = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("description", x);
            }
            xs.takeEnd("description");
        }
        {
            xs.takeStart("state");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _State = Integer.parseInt(s);
            } catch (Exception x) {
                throw new ConversionException("state", x);
            }
            has_State = true;
            xs.takeEnd("state");
        }
        xs.takeEnd("item");
    }

    public static Item unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static Item unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static Item unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((Item) d.unmarshal(xs, (Item.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof Item)) {
            return false;
        }
        Item tob = ((Item) ob);
        if (has_Number) {
            if (!tob.has_Number) {
                return false;
            }
            if (_Number!= tob._Number) {
                return false;
            }
        } else {
            if (tob.has_Number) {
                return false;
            }
        }
        if (has_Priority) {
            if (!tob.has_Priority) {
                return false;
            }
            if (_Priority!= tob._Priority) {
                return false;
            }
        } else {
            if (tob.has_Priority) {
                return false;
            }
        }
        if (_Description!= null) {
            if (tob._Description == null) {
                return false;
            }
            if (!_Description.equals(tob._Description)) {
                return false;
            }
        } else {
            if (tob._Description!= null) {
                return false;
            }
        }
        if (has_State) {
            if (!tob.has_State) {
                return false;
            }
            if (_State!= tob._State) {
                return false;
            }
        } else {
            if (tob.has_State) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((31 *h)+ _Number);
        h = ((31 *h)+ _Priority);
        h = ((127 *h)+((_Description!= null)?_Description.hashCode(): 0));
        h = ((31 *h)+ _State);
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<item");
        if (has_Number) {
            sb.append(" number=");
            sb.append(Integer.toString(_Number));
        }
        if (has_Priority) {
            sb.append(" priority=");
            sb.append(Integer.toString(_Priority));
        }
        if (_Description!= null) {
            sb.append(" description=");
            sb.append(_Description.toString());
        }
        if (has_State) {
            sb.append(" state=");
            sb.append(Integer.toString(_State));
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        Dispatcher d = new Dispatcher();
        d.register("item", (Item.class));
        d.register("todolist", (Todolist.class));
        d.freezeElementNameMap();
        return d;
    }

}
