/*
 * TestJAXB.java
 *
 * Programma di test per JAXB.
 */

import java.io.*;
import java.util.*;
import javax.xml.bind.*;
import javax.xml.marshal.*;

/**
 *
 * @author  Andrea Giovannini
 */
public class TestJAXB {

    public static void main(String args[]) throws Exception {
        File inputFile = new File(args[0]);
        FileInputStream fis = new FileInputStream(inputFile);

        // Popola la todolist con i dati specificati nel file XML
        Todolist list = Todolist.unmarshal(fis);

        List todolist = list.getItem();

        // Modifica la collezione
        for(Iterator i=todolist.iterator(); i.hasNext(); ) {
            Item item = (Item)i.next();
            // impostiamo tutte le attivit come da iniziare
            item.setState(0);
        }

        // Aggiungiamo una nuova attivit
        Item item = new Item();
        item.setNumber(4);
        item.setPriority(10);
        item.setDescription("Leggere MokaByte");
        item.setState(0);
        
        todolist.add(item);

        // Validazione dei dati
        list.validate();

        // Salva i dati sul file XML
        File outFile = new File(args[1]);
        FileOutputStream fos = new FileOutputStream(outFile);
        list.marshal(fos);
    }



}
