
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.InvalidContentObjectException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.MarshallableRootElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PredicatedLists;
import javax.xml.bind.PredicatedLists.Predicate;
import javax.xml.bind.RootElement;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.ValidatableObject;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class Todolist
    extends MarshallableRootElement
    implements RootElement
{

    private List _Item = PredicatedLists.createInvalidating(this, new ItemPredicate(), new ArrayList());
    private PredicatedLists.Predicate pred_Item = new ItemPredicate();

    public List getItem() {
        return _Item;
    }

    public void deleteItem() {
        _Item = null;
        invalidate();
    }

    public void emptyItem() {
        _Item = PredicatedLists.createInvalidating(this, pred_Item, new ArrayList());
    }

    public void validateThis()
        throws LocalValidationException
    {
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
        for (Iterator i = _Item.iterator(); i.hasNext(); ) {
            v.validate(((ValidatableObject) i.next()));
        }
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("todolist");
        if (_Item.size()> 0) {
            for (Iterator i = _Item.iterator(); i.hasNext(); ) {
                m.marshal(((MarshallableObject) i.next()));
            }
        }
        w.end("todolist");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("todolist");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        {
            List l = PredicatedLists.create(this, pred_Item, new ArrayList());
            while (xs.atStart("item")) {
                l.add(((Item) u.unmarshal()));
            }
            _Item = PredicatedLists.createInvalidating(this, pred_Item, l);
        }
        xs.takeEnd("todolist");
    }

    public static Todolist unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static Todolist unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static Todolist unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((Todolist) d.unmarshal(xs, (Todolist.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof Todolist)) {
            return false;
        }
        Todolist tob = ((Todolist) ob);
        if (_Item!= null) {
            if (tob._Item == null) {
                return false;
            }
            if (!_Item.equals(tob._Item)) {
                return false;
            }
        } else {
            if (tob._Item!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_Item!= null)?_Item.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<todolist");
        if (_Item!= null) {
            sb.append(" item=");
            sb.append(_Item.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return Item.newDispatcher();
    }


    private static class ItemPredicate
        implements PredicatedLists.Predicate
    {


        public void check(Object ob) {
            if (!(ob instanceof Item)) {
                throw new InvalidContentObjectException(ob, (Item.class));
            }
        }

    }

}
