/*
 * TestJAXB.java
 *
 * Programma di test per JAXB.
 */

import java.io.*;
import java.util.*;

/**
 *
 * @author  Andrea Giovannini
 */
public class TestZeus {

    public static void main(String args[]) throws Exception {
        File inputFile = new File(args[0]);

        // Popola la todolist con i dati specificati nel file XML
        Todolist list = TodolistUnmarshaller.unmarshal(inputFile);

        List todolist = list.getItemList();

        // Modifica la collezione
        for(Iterator i=todolist.iterator(); i.hasNext(); ) {
            Item item = (Item)i.next();
            // impostiamo tutte le attivit come da iniziare
            State state = new StateImpl();
            state.setValue("0");
            item.setState(state);
        }

        // Aggiungiamo una nuova attivit
        Item item = new ItemImpl();
        NumberImpl number = new NumberImpl();
        number.setValue("4");
        item.setNumber(number);
        Priority priority = new PriorityImpl();
        priority.setValue("10");
        item.setPriority(priority);
        Description description = new DescriptionImpl();
        description.setValue("Leggere MokaByte");
        item.setDescription(description);
        State state = new StateImpl();
        state.setValue("0");
        item.setState(state);

        todolist.add(item);


        // Salva i dati sul file XML
        list.marshal(new File(args[1]));
    }



}
